# Programm zur Loesung der Aufgabe 10.8, FEM, quadratische Elemente
# -((1+c*x^2)u_x)_x + d*u = exp(-x^2), u(0)=0, [u_x + alpha*u](1) = peta
# Input:  c,d,alpha,peta und Zahl der ganzen Indizes n
# Output: Loesung u an den Stuetzstellen x, Matrix a und rechte Seite f
# Aufruf: [u,x,a,f] = aufg98fem2(c,d,alpha,peta,n);
function [u,x,a,f] = aufg98fem2(c,d,alpha,peta,n);
m = 2*n; h = 1/n; h2 = h/2; h3 = 1/(h*3); h15 = h/15;
h163 = 16/(h*3); h83 = 8/(h*3); h143 = 14/(h*3);
x(1) = 0;
f = zeros(m,1);
a = zeros(2*n,2*n);
for i=1:m
   x(i+1)=i*h2;
endfor
# Aufbau der Steifigkeitsmatrix a und des Lastvektors f
for i=1:n
   jh = 2*i-1;
   j = 2*i;
   if (i == 1)
     a(jh,jh) = h163*(1+c*(x(jh)^2+h*x(jh)+2*h^2/5))+d*8*h15; 
     a(jh,jh+1) = -h83*(1+c*(x(jh)^2+3*h*x(jh)/2+13*h^2/20))+d*h15;
     a(j,j-1) = -h83*(1+c*(x(j-1)^2+3*h*x(j-1)/2+13*h^2/20))+d*h15;
     a(j,j) = h143*(1+c*((x(j-1)^2+x(j+1)^2)/2+11*h*x(j-1)/14 ...
                          +3*h*x(j+1)/14+13*h^2/35))+d*4*h15;
     a(j,j+1) = -h83*(1+c*(x(j+1)^2+h*x(j+1)/2+3*h^2/20))+d*h15;
     a(j,j+2) = h3*(1+c*(x(j+1)^2+h*x(j+1)+3*h^2/5))-d*h15/2;
   endif
   if (2 < j && j < m )
     a(j,j-2) = h3*(1+c*(x(j-1)^2+h*x(j-1)+3*h^2/5))-d*h15/2;
     a(j,j-1) = -h83*(1+c*(x(j-1)^2+3*h*x(j-1)/2+13*h^2/20))+d*h15;
     a(j,j) = h143*(1+c*((x(j-1)^2+x(j+1)^2)/2+11*h*x(j-1)/14 ...
                           +3*h*x(j+1)/14+13*h^2/35))+d*4*h15;
     a(j,j+1) = -h83*(1+c*(x(j+1)^2+h*x(j+1)/2+3*h^2/20))+d*h15;
     a(j,j+2) = h3*(1+c*(x(j+1)^2+h*x(j+1)+3*h^2/5))-d*h15/2;
   endif
   if (1 < jh )
     a(jh,jh-1) = -h83*(1+c*(x(jh)^2+h*x(jh)/2+3*h^2/20))+d*h15;
     a(jh,jh) = h163*(1+c*(x(jh)^2+h*x(jh)+2*h^2/5))+d*8*h15; 
     a(jh,jh+1) = -h83*(1+c*(x(jh)^2+3*h*x(jh)/2+13*h^2/20))+d*h15;
   endif
   if (j == m)
     a(j,j-2) = h3*(1+c*(x(j-1)^2+h*x(j-1)+3*h^2/5))-d*h15/2;
     a(j,j-1) = -h83*(1+c*(x(j-1)^2+3*h*x(j-1)/2+13*h^2/20))+d*h15;
     a(j,j) = 7*h3*(1+c*(x(j-1)^2+11*h*x(j-1)/7+23*h^2/35))+d*2*h15+2*alpha;
   endif
   f(jh) = exp(-x(j)^2)*2*h/3;
   f(j) = (exp(-x(j)^2)+exp(-x(j+1)^2))*h/6;
   if (j == m)
      f(j) = exp(-x(j)^2)*h/6 + 2*peta;
   endif
endfor
# Loesung
uu = a\f;
u(1) = 0;
for i=1:m
   u(i+1) = uu(i);
endfor
endfunction
