# Programm aufg24 zur LR-Zerlegung und Rangberechnung einer Matrix A
# input:  Matrix a(n,m), m>n
# output: untere Dreiecksmatrix ll(n,n) mit Einsen auf der Diagonale,
#         obere Dreiecks- bzw. Echolonmatrix rr(n,m)
#         z Permutationsmatrix entsprechend der Zeilenvertauschungen
#         es gilt  z*a = ll*rr
#         ra Rang der Matrix a
# aufruf: [ll,rr,z,ra] = aufg24(a);
function [ll,rr,z,ra] = aufg24(a);
n = length(a(:,1));
m = length(a(1,:));
z = eye(n);
ll = eye(n);
rr = zeros(n,m);
# Elimination
for j=1:m-1
# Pivotsuche
  apivot=abs(a(j,j));
  p=j;
  for l=j+1:n
    if (abs(a(l,j)) > abs(apivot))
      apivot=a(l,j);
      p=l;
    endif
  endfor
  if (apivot ~= 0)
# Vertauschung der Zeilen j und p
    for i=1:m
      c=a(j,i);
      a(j,i)=a(p,i);
      a(p,i)=c;
    endfor
    for i=1:n
      pp=z(j,i);
      z(j,i)=z(p,i);
      z(p,i)=pp;
    endfor
# Elimination
    for i=j+1:n
      a(i,j)=a(i,j)/a(j,j);
      for k=j+1:m
        a(i,k)=a(i,k)-a(i,j)*a(j,k);
      endfor
    endfor
  endif
endfor
#
if (n == m)
  idet = 0;
  amin = 10000;
  for j=1:n
    if (a(n,j) ~= 0)
      idet = idet + 1;
    endif
    if (abs(a(n,j)) < amin)
      amin = abs(a(n,j));
    endif
  endfor
  if (idet == 0 || amin < 1.0e-10)
    disp('Matrix singulaer');
  endif
endif
#
for i=1:n
  for j=1:m
    if (i <= j)
      rr(i,j) = a(i,j);
    endif
  endfor
endfor
for i=1:n
  for j=1:n
    if (i > j)
      ll(i,j) = a(i,j);
    endif
  endfor
endfor
# 
ra = 0;
for i=1:n
  if (abs(rr(i,m)) > 1.0e-10)
    ra = ra + 1;
  endif
endfor
endfunction
