# Programm aufg27 zur Cholesky-Zerlegung einer symm. tridiagonalen Matrix
# input:  Diagonalen der Matrix, Hauptdiagonale d(1:n), 
#         Nebendiagonale u(1:n), u(1) ist dummy-Element
# output: Diagonalen von L, d.h. Hauptdiagonale D(1:n) und 
#         Nebendiagonale U(1:n), U(1) ist dummy-Element
# aufruf: [D,U] = aufg27(d,u);
function [D,U] = aufg27(d,u);
n = length(d);
D = ones(n,1); U = ones(n,1);
U(1) = 0;
for k=1:n
	D(k) = sqrt(d(k) - U(k)^2);
	if (k < n)
		U(k+1) = u(k+1)/D(k);
	endif
endfor
endfunction
