# Programm aufg45 zur Berechnung der Eigenwerte und Eigenvektoren
# einer reellen symmetrischen Matrix a
# input:  Matrix a vom Typ (n x n), toleranz epsilon, kappa Wilkinson-shift
# output: Matrix lambda mit den Eigenwerten auf der Hauptdiagonalen
#         Matrix qh mit den Eigenvektoren als Spalten
#         Residuum resi, Iterationszahl iter
# aufruf: [lambda,qh,resi,iter] = aufg45(a,kappa,epsilon);
# benoetigte Programme: hessenberg_gb.m, qriteration_gb.m
function [lambda,qh,resi,iter] = aufg45(a,kappa,epsilon);
n = length(a(1,:));
# Transformation von a auf Hessenbergform
[h,qt] = hessenberg_gb(a);
p = eye(n);
resi = epsilon + 1;
iter = 1;
# Ermittlung der Maschinengenauigkeit
tau = 1;
while ((tau+1)>1)
  tau = tau/2;
endwhile
# qr-Iteration
while (resi > epsilon && iter < 200)
  [h,p] = qriteration_gb(h,p,kappa,tau); 
  resi = 0;
  for i=1:n
    for j=1:n
      if (i > j)
        resi = resi + abs(h(i,j));
      endif
    endfor 
  endfor 
  iter = iter + 1;
endwhile
if (resi > epsilon)
  printf('keine Konvergenz');
  return
endif
printf('Konvergenz, Residuum: ');
resi
printf('Iterationszahl: ');
iter
lambda = h;
qh = qt'*p;
endfunction
