# Programm zur Berechnung des Integrals \int_0^\pi sin(x) dx
# mit der Monte-Carlo-Methode
# input:  z, Feld von nsamples Zufallszahlen
# output: integral genaeherter Integralwert, fehler
# Aufruf: [integral,fehler] = montecarlo1(z,nsamples);
function [integral,fehler] = montecarlo1(z,nsamples);
dichte = 2/pi;
mw = 0;
var = 0;
for j=1:nsamples
  xi = pi*z(j)/2;
  mw = mw + sin(xi)/dichte;
  var = var + (sin(xi)/dichte)^2;
endfor
integral = mw/nsamples;
fehler = sqrt((var/nsamples - integral^2)/nsamples);
endfunction
