# Programm Uebungsaufgabe 7.8 zum SQP-Verfahren (sqp3_gb.m)
# Min F(x,y,z) , u.d.N. G(x,y,z) = 0
#
# F, G, gradF und gradG sind als Programme (Function)
# Spaltenvektoren, bereitzustellen
# input:  Startwert (x0,y0,z0,lambda0), Lagrange-Multiplikator 
# output: Loesung (x*,y*,z*,lambda*), F(x*,y*,z*) und G(x*,y*,z*)
# Aufruf: [xs,ys,zs,lambda,f,g] = sqp3_gb(x0,y0,z0,lambda0)
# 
function [xs,ys,zs,lambdas,f,g] = sqp2_gb(x0,y0,z0,lambda0)
M = zeros(4,4);
x = x0; y= y0; z=z0; lambda = lambda0;
B = [2*lambda , z , y ; z , 2*lambda , x ; y , x , 2*lambda];
M = [ B , gradG(x,y,z); gradG(x,y,z)', 0];
rhs = [-gradF(x,y,z)-lambda*gradG(x,y,z) ; -G(x,y,z)];
#
epsilon = 0.000001;
k = 0;
while abs(G(x,y,z)) > epsilon  &&  k < 30
   k = k + 1
   X = M\rhs;
   dx = X(1); dy = X(2); dz = X(3); dlambda = X(4);
   x = x + dx; y = y + dy; z = z + dz; lambda = lambda + dlambda;
   B = [2*lambda , z , y ; z , 2*lambda , x ; y , x , 2*lambda];
   M = [ B , gradG(x,y,z); gradG(x,y,z)' , 0];
   rhs = [-gradF(x,y,z)-lambda*gradG(x,y,z) ; -G(x,y,z)];
endwhile
xs = x;
ys = y;
zs = z;
lambdas = lambda;
f= F(x,y,z);
g = G(x,y,z);
endfunction
#
function grad = gradF(x,y,z);
grad = [y*z ; x*z ; x*y];
endfunction
#
function grad = gradG(x,y,z);
grad = [2*x ; 2*y ; 2*z ];
endfunction
#
function f = F(x,y,z);
f = x*y*z ;
endfunction
#
function g = G(x,y,z);
g = x^2 + y^2 +  z^2 -1; 
endfunction

